
set echo on
set serveroutput on

DECLARE

   v_anydata ANYDATA;

   PROCEDURE generic_procedure( p_anydata IN ANYDATA ) IS

      v_typename VARCHAR2(128);
      v_value    VARCHAR2(32767);

   BEGIN

      v_typename := p_anydata.GetTypeName;

      EXECUTE IMMEDIATE 'DECLARE 
                            v_object ' || v_typename || ';
                            v_anydata     ANYDATA := :bv1_in;
                            v_dummy       PLS_INTEGER;
                         BEGIN
                            v_dummy := v_anydata.GetObject(v_object);
                            :bv2_out := v_object.print();
                         END;'
                  USING  IN  p_anydata,
                         OUT v_value;
   
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------------');
      DBMS_OUTPUT.PUT_LINE('Type name  : ' || v_typename);
      DBMS_OUTPUT.PUT_LINE('Type value : ' || v_value);

   END generic_procedure;

BEGIN

   /*
   || Test an EMP record...
   */
   SELECT ANYDATA.ConvertObject(
             emp_ot(empno, ename, job, mgr, hiredate, sal, comm, deptno)
             )
   INTO   v_anydata
   FROM   emp
   WHERE  ROWNUM = 1;
   
   generic_procedure(v_anydata);

   /*
   || Test a DEPT record...
   */
   SELECT ANYDATA.ConvertObject(
             dept_ot(deptno, dname, loc)
             )
   INTO   v_anydata
   FROM   dept
   WHERE  ROWNUM = 1;

   generic_procedure(v_anydata);

END;
/


