
set echo on
set serveroutput on

DECLARE

   v_anydata ANYDATA;
   v_emps    emp_ntt;
   v_emp     emp_ot;
   v_dummy   PLS_INTEGER;

BEGIN

   /* Fetch data into collection... */
   SELECT emp_ot(empno, ename, job, mgr, hiredate, sal, comm, deptno)
   BULK COLLECT INTO v_emps
   FROM emp;

   /* Assign and access an object... */
   v_anydata := ANYDATA.ConvertObject(v_emps(v_emps.FIRST));
   v_dummy := v_anydata.GetObject(v_emp);
   DBMS_OUTPUT.PUT_LINE('Accessed emp ' || v_emp.ename);

   /* Assign and access a collection (access will overwrite original v_emps)... */
   v_anydata := ANYDATA.ConvertCollection(v_emps);
   v_dummy := v_anydata.GetCollection(v_emps);
   DBMS_OUTPUT.PUT_LINE('Accessed ' || v_emps.COUNT || ' emps');

END;
/

   
